<?php
function me2PersonInfo($id){
	$me2Person = me2day_getXMLResource("http://me2day.net/api/get_person/{$id}.xml");
	if (!is_null($me2Person) && is_array($me2Person) && count($me2Person) > 0) {
		$encodename = str_replace(basename($me2Person['face']), urlencode(basename($me2Person['face'])), $me2Person['face']);
		$me2Person['face'] = $encodename;
		$me2Result = $me2Person;
	} else {
		$me2Result = _t('<p>정보가 없거나 가져올 수 없습니다. <br /> 잠시후 다시 시도하세요.</p>');
	}
	unset($me2Person);
	return $me2Result;
}

function me2FamilyLine($id){
	global $pluginURL;
	$me2Result = me2FamilyLineShow($id);
	$me2Result = array_reverse(explode("|", $me2Result));
	$result  = "<div id=\"me2FamilyLine\">".CRLF;
	$result .= "<div id=\"innerline\">".CRLF;
	$i = 0;
	foreach ($me2Result as $item){
		if($i != 0) $result .= "<div class='familyArrow'></div>";
		$result .= $item;
		$i++;
	}
	$result .= "</div>".CRLF;
	$result .= "</div>";
	return $result;
}
function me2FamilyLineShow($id){
	global $blogURL, $pluginMenuURL;
	$permalink = "{$pluginMenuURL}&amp;";
	$me2FamilyLine = me2day_getXMLResource("http://me2day.net/api/get_person/{$id}.xml");
	if (!is_null($me2FamilyLine) && is_array($me2FamilyLine) && count($me2FamilyLine) > 0) {
		$encodename = str_replace(basename($me2FamilyLine['face']), urlencode(basename($me2FamilyLine['face'])), $me2FamilyLine['face']);
		$me2Result  = TAB."<div class='family'>".CRLF;
		$me2Result .= TAB.TAB."<div class='familyIMG'><span title=\" &raquo; 친구들 : ".$me2FamilyLine['friendsCount']."명 #13; &raquo; ".str_replace(array('"','<','>'),array('&quot;','&lt;','&gt;'),$me2FamilyLine['description'])." \"><img src='".$encodename."' width='77' height='77' onclick=\"location.href='{$permalink}id={$me2FamilyLine['id']}';\" onError=\"this.src='http://me2day.net/images/profile.gif';\" /></span></div>".CRLF;	
		$me2Result .= TAB.TAB."<div class='familyINFO'>".CRLF;
		$me2Result .= TAB.TAB.TAB."&raquo; <a href=\"{$me2FamilyLine['me2dayHome']}\" onclick=\"window.open(this.href); return false;\" title=\"{$me2FamilyLine['nickname']}님 미투로 가기\">{$me2FamilyLine['id']}</a><br/>".CRLF;
		$me2Result .= TAB.TAB.TAB."&raquo; ".(($me2FamilyLine['homepage'])?"<a href=\"".$me2FamilyLine['homepage']."\" onclick=\"window.open(this.href); return false;\" title=\"{$me2FamilyLine['nickname']}님 홈피로 가기\">".UTF8::lessenAsEm($me2FamilyLine['nickname'],18)."</a>":"<a>".UTF8::lessenAsEm($me2FamilyLine['nickname'],18)."</a>")."<br/>".CRLF;
		$me2Result .= TAB.TAB.TAB."&raquo; <span class='friendCount'>friends({$me2FamilyLine['friendsCount']})</span>".CRLF;
		$me2Result .= TAB.TAB."</div>".CRLF;
		$me2Result .= TAB."</div>".CRLF;
		if($me2FamilyLine['invitedBy']){
			$temp = me2FamilyLineShow($me2FamilyLine['invitedBy']);
			$me2Result .= "|".$temp;		
		}
	} else {
		$me2Result = _t('<p>정보가 없거나 가져올 수 없습니다. <br /> 잠시후 다시 시도하세요.</p>');
	}
	unset($me2FamilyLine);
	return $me2Result;
}

function me2Friends($id, $field, $direction, $scope, $mytag){
	global $blogURL, $defaultURL, $pluginURL, $pluginMenuURL;
	$permalink  = "{$pluginMenuURL}&amp;";
	if($scope == "mytag"){
		$tagArray = array($mytag);
		$me2Friends = me2day_getXMLResource("",get_me2dayAccessAPI($tagArray));
	}else{
		$scope = ($scope)?"?scope={$scope}":"?scope=all";
		$me2Friends = me2day_getXMLResource("http://me2day.net/api/get_friends/{$id}.xml".$scope);
	}
	$me2Intimate = me2day_getXMLResource("http://me2day.net/api/get_friends/{$id}.xml?scope=close");
	$me2Families = me2day_getXMLResource("http://me2day.net/api/get_friends/{$id}.xml?scope=family");
	$intimateCount = count($me2Intimate);
	$familiesCount = count($me2Families);
    $sort_array = array();
    foreach($me2Friends AS $uniqid => $item){
        foreach($item AS $key=>$value){
            $sort_array[$key][$uniqid] = $value;
        }
    }
	$direction = ($direction == "asc")?SORT_ASC:SORT_DESC;

	$me2Result  = "<div id=\"me2Friends\">".CRLF;
	$me2Result .= TAB."<div class='friends'>".CRLF;
	$me2Result .= TAB.TAB."<span title=\" &raquo; 친구들 : 다수 #13; &raquo; 랜덤으로 me2day 사용자를 선택합니다. \"><img src='{$pluginURL}/lib/random.gif' width='77' height='77' onclick=\"location.href='{$permalink}id=random';\" onError=\"this.src='http://me2day.net/images/profile.gif';\" /></span><br/>".CRLF;
	$me2Result .= TAB.TAB."&raquo; <a href=\"{$blogURL}/plugin/me2randomgo/\" onclick=\"window.open(this.href); return false;\" title=\"랜덤으로 미투 가기\">random</a><br/>".CRLF;
	$me2Result .= TAB.TAB."&raquo; 랜더미^^;".CRLF;
	$me2Result .= TAB."</div>".CRLF;
	if (!is_null($me2Friends) && is_array($me2Friends) && count($me2Friends) > 0) {
		array_multisort($sort_array[$field], $direction, $me2Friends);
		foreach ($me2Friends as $friend){
			$encodename = str_replace(basename($friend['face']), urlencode(basename($friend['face'])), $friend['face']);
			$me2Result .= TAB."<div class='friends'>".CRLF;
			$me2Result .= TAB.TAB."<span title=\" &raquo; 친구들 : ".$friend['friendsCount']."명 #13; &raquo; ".str_replace(array('"','<','>'),array('&quot;','&lt;','&gt;'),$friend['description'])." \"><img src='".$encodename."' width='77' height='77' onclick=\"location.href='{$permalink}id={$friend['id']}';\" onError=\"this.src='http://me2day.net/images/profile.gif';\" /></span><br/>".CRLF;
			$me2Result .= TAB.TAB."&raquo; <a href=\"{$friend['me2dayHome']}\" onclick=\"window.open(this.href); return false;\" title=\"{$friend['nickname']}님 미투로 가기\">".UTF8::lessenAsEm($friend['id'],12)."</a><br/>".CRLF;
			$me2Result .= TAB.TAB."&raquo; ".(($friend['homepage'])?"<a href=\"".$friend['homepage']."\" onclick=\"window.open(this.href); return false;\" title=\"{$friend['nickname']}님 홈피로 가기\">".UTF8::lessenAsEm($friend['nickname'],10)."</a>":"<a>".UTF8::lessenAsEm($friend['nickname'],10)."</a>").CRLF;
			$me2Result .= TAB."</div>".CRLF;
		}
	} else {
		$me2Result .= _t('<p>정보가 없거나 가져올 수 없습니다. <br /> 잠시후 다시 시도하세요.</p>');
	}
	$me2Result .= "</div>";
	unset($me2FamilyLine);
	return array($me2Result, $intimateCount, $familiesCount);
}

function get_me2dayRandomUser(){
	global $blogURL, $pluginURL, $service;
	requireComponent("Eolin.PHP.Core");
	$me2Users = ROOT.str_replace($service['path'], '', $pluginURL)."/lib/me2users.xml";
	$userArray = array();
	if (file_exists($me2Users)) {
		if ($xml = @file_get_contents($me2Users)) {
			$xml = base64_decode($xml);
			$xmls = new XMLStruct();
			$xmls->open($xml,$service['encoding']);
			if ($xmls->doesExist('/me2users')) {
				for ($i = 0; $xmls->getValue("/me2users/id[$i]"); $i++);
				$rndKey = rand(0, ($i-1));
				$value = $xmls->getValue("/me2users/id[$rndKey]");
			}
		}
	}
	return $value;
}

function get_me2dayRandomMe2Go($target){
	global $owner;
	if(!empty($_SESSION['userid']) || ($_SESSION['userid'] == $owner)){
		ob_start();
			header("Location: http://me2day.net/".get_me2dayRandomUser());
		ob_end_flush();
	}else{
		echo _t('관리자 세션이 종료되어 사용할 수 없습니다.');
	}
}

function me2day_getAlterUrl($link,$urlInfo){
	requireComponent('Tattertools.Function.misc');
	$attributes = misc::getAttributesFromString($link);
	if(!isset($attributes['href'])) return false;
	$rssInfo = parse_url($attributes['href']);
	$rssURL = false;
	if(isset($rssInfo['scheme']) && $rssInfo['scheme'] == 'http')
		$rssURL = $attributes['href'];
	else if(isset($rssInfo['path'])) {
		if($rssInfo['path']{0} == '/')
			$rssURL = "{$urlInfo['scheme']}://{$urlInfo['host']}{$rssInfo['path']}";							
		else
			$rssURL = "{$urlInfo['scheme']}://{$urlInfo['host']}".(isset($urlInfo['path']) ? rtrim($urlInfo['path'], '/') : '').'/'.$rssInfo['path'];
	}
	return $rssURL;
}

function me2day_getRemoteXml($url){
	requireComponent('Eolin.PHP.HTTPRequest');
	$request = new HTTPRequest($url);
	$request->timeout = 3;
	if (!$request->send())
		return null;
	$xml = $request->responseText;
	$xml = me2day_uft8html2utf8($xml);
	unset($request);
	return $xml;
}

function me2day_uft8html2utf8( $s ) {
	if ( !function_exists('me2day_uft8html2utf8_callback') ) {
		function me2day_uft8html2utf8_callback($t) {
			$dec = $t[1];
			if ($dec < 128) {
				$utf = chr($dec);
			} else if ($dec < 2048) {
				$utf = chr(192 + (($dec - ($dec % 64)) / 64));
				$utf .= chr(128 + ($dec % 64));
			} else {
				$utf = chr(224 + (($dec - ($dec % 4096)) / 4096));
				$utf .= chr(128 + ((($dec % 4096) - ($dec % 64)) / 64));
				$utf .= chr(128 + ($dec % 64));
			}
			return $utf;
		}
	}
	return preg_replace_callback('|&#([0-9]{1,});|', 'me2day_uft8html2utf8_callback', $s );
}

function me2day_getXMLResource($url, $tempxml="") {
	global $service;
	if($tempxml){
		$xml = me2day_uft8html2utf8($tempxml);
	}else{
		$xml = me2day_getRemoteXml($url);
	}
	$xmls = new XMLStruct();
	$items = array();
	if (!$xmls->open($xml, $service['encoding'])) {
		if(preg_match_all('/<id>.*?</id>/i', $xml, $matches)) {
			$urlInfo = parse_url($url);
			foreach($matches[0] as $link) {
				$rssURL = me2day_getAlterUrl($link,$urlInfo);
				if($rssURL && $url != $rssURL)
					return me2day_getXMLResource($rssURL);
			}
		}
	}else if ($xmls->doesExist('/person')) {
		$items['id'] = $xmls->getValue("/person/id");
		$items['nickname'] = $xmls->getValue("/person/nickname");
		$items['face'] = $xmls->getValue("/person/face");
		$items['description'] = $xmls->getValue("/person/description");
		$items['description'] = ereg_replace("[^a-zA-Z가-힣0-9]"," ",$items['description']);
		$items['homepage'] = $xmls->getValue("/person/homepage");
		$items['me2dayHome'] = $xmls->getValue("/person/me2dayHome");
		$items['invitedBy'] = $xmls->getValue("/person/invitedBy");
		$items['friendsCount'] = $xmls->getValue("/person/friendsCount");
		$items['updated'] = $xmls->getValue("/person/updated");
	}else if ($xmls->doesExist('/friends/person')) {
		$item = array();
		for ($i = 0; $item['id'] = $xmls->getValue("/friends/person[$i]/id"); $i++) {
			$item['nickname'] = $xmls->getValue("/friends/person[$i]/nickname");
			$item['face'] = $xmls->getValue("/friends/person[$i]/face");
			$item['description'] = $xmls->getValue("/friends/person[$i]/description");
			$item['description'] = ereg_replace("[^a-zA-Z가-힣0-9]"," ",$item['description']);
			$item['homepage'] = $xmls->getValue("/friends/person[$i]/homepage");
			$item['me2dayHome'] = $xmls->getValue("/friends/person[$i]/me2dayHome");
			$item['invitedBy'] = $xmls->getValue("/friends/person[$i]/invitedBy");
			$item['friendsCount'] = $xmls->getValue("/friends/person[$i]/friendsCount");
			$item['updated'] = $xmls->getValue("/friends/person[$i]/updated");
			array_push($items, $item);
		}
	}
	return $items;
}

function CT_me2day_CreatePost($target){
	global $service, $pluginURL, $configVal;
	requireComponent('Tattertools.Function.misc');
	$data = misc::fetchConfigVal($configVal);
	$me2flagCHK = "";
	$me2flagMSG = "";
	if(is_null($data) || !isset($data['me2dayID']) || !isset($data['me2apiKEY'])){
		$me2flagCHK = "disabled";
		$me2flagMSG = " * me2day 사용자 정보를 설정해야 합니다.\n * 아이디와 me2API 키를 입력하세요.\n * me2API 키는 me2day 관리에서 확인.";
	}
	ob_start();
?>
<script type="text/javascript" src="<?php echo $pluginURL;?>/lib/me2day.js"></script>
<link rel="stylesheet" type="text/css" media="screen" href="<?php echo $pluginURL;?>/lib/me2style.css" />
<div id="me2CP_outer" style="border:1px solid #d7d7d7; margin-top:5px; width:298px;"><div id="me2CP_inner" style="border:4px solid #f4f4f4; padding:4px;">
	글종류 : 
	<select id="post_kind" <?php echo $me2flagCHK;?> style="width:70px;">
		<option value="1" selected>생각글</option>
		<option value="2">느낌글</option>
		<option value="3">알림글</option>
	</select>
	, 아이콘 : 
	<select id="post_icon" <?php echo $me2flagCHK;?> style="width:80px;">
		<option value="" selected></option>
		<option value="1">1. 생각글</option>
		<option value="2">2. 느낌글</option>
		<option value="3">3. 알림글</option>
		<? for ($i = 4; $i < 13; $i++) { echo '<option value="'.$i.'">'.$i.'. 사용자</option>'; } ?>
	</select><br />
	(※ 아이콘 선택시 글종류 선택값은 무시됨.)<br />
	<textarea id="post_body" maxlength="150" onkeypress="if (event.keyCode == 13) { return false; }" <?php echo $me2flagCHK;?> style="width:276px; height:57px; margin-bottom:2px; border:1px solid #dedede;"><?php echo $me2flagMSG;?></textarea><br />
	<div align="right">
		태그(구분은 공백) : <input type="text" id="post_tags" onkeypress="if (event.keyCode == 13) { return false; }" <?php echo $me2flagCHK;?> style="width:130px; border:1px solid #dedede; margin-bottom:1px;"/>
		<input id="post_button" type="button" value="저 장" onclick="me2Create_Post('','','','','create');" <?php echo $me2flagCHK;?> style="border:1px solid #d7d7d7; background-color:#eaeaea; font-size:9pt; height:18px; color:#555555;"/>
	</div>
</div></div>
<?php
	$target = ob_get_contents();
	ob_end_clean();
	return $target;
}

function get_me2dayBookmarklet($target) {
	global $owner, $blogURL, $defaultURL, $pluginURL, $configVal;
	requireComponent('Eolin.PHP.HTTPRequest');
	requireComponent('Tattertools.Function.misc');
	$data = misc::fetchConfigVal($configVal);
	ob_start();
	?>
	<script type="text/javascript" src="<?php echo $pluginURL;?>/lib/me2day.js"></script>
	<script type="text/javascript" src="<?php echo $pluginURL;?>/lib/IEprompt.js"></script>
	<script type="text/javascript">
	//<![CDATA[

	String.prototype.strip_tags = function() {return this.replace(/<\/?[^>]+>/gi, '');}
	function me2dayBookmarklet() {
	<?php
		if(!is_null($data) && isset($data['me2dayID']) && isset($data['me2apiKEY'])){
	?>
		var oForm = document.forms[0];
		if(entryId != 0){
			var title = trim(oForm.title.value);
			if (title.length == 0) {
				alert("제목을 입력해 주십시오.");
				oForm.title.focus();
				return false;
			}

			var visibility = 0;
			for (var i = 0; i < oForm.visibility.length; i++) {
				if (oForm.visibility[i].checked) {
					visibility = oForm.visibility[i].value;
					break;
				}
			}

			if (visibility == 0) {
				alert("비공개 글은 미투데이로 북마클릿 할 수 없습니다.");
				oForm.title.focus();
				return false;
			}

			var tagValue = "";
			try {
				tagValue = oTag.getValues().join(" ");
			} catch (e) {
				tagValue = oForm.tag.value;
			}
			tagValue = (tagValue) ? tagValue + " me2blog" : "me2blog";

			var content = "";
			if (!confirm('현재 글에 대한 추가 글을 입력 하시겠습니까?\t\n(취소선택 : 본문 요약글 자동 입력.)')){
				if(editor.editMode == "WYSIWYG") {
					content = editor.contentDocument.body;
					content = (document.all) ? content.innerText : content.textContent;
					content = content.substring(0,55).replace(/\.+$/,"")+"...";
				}else{
					content = document.getElementById("editWindow").value;
					content = content.strip_tags();
					content = content.substring(0,55).replace(/\.+$/,"")+"...";
				}
				content = "  :: " + content;
			}else{
				if(content = prompt('미투데이로 북마클릿 할 현재 글에 대한 추가 글을 입력해 주세요.\t', '')){
					if(content && content != null) content = "  :: " + content;
				}else{
					content = "";
				}
			}

			post_body = '"' + title + '":<?php echo $defaultURL;?>/' + entryId + content;
			post_tags = tagValue;
			post_kind = 3;
			post_icon = "";

			me2Create_Post(post_body, post_tags, post_kind, post_icon, "bookmarklet")
		}else{
			alert("저장 후 미투데이로 북마클릿 할 수 있습니다.");
		}
	<?php
		}else{
	?>
			alert("미투데이 설정이 잘못 되었습니다. 아이디와 me2API 키값을 확인해 주십시오.   ");
	<?php
		}
	?>
	}
	//]]>
	</script>
	<?
	$script = ob_get_contents();
	ob_end_clean();
	echo $script;
	$target .= "<img style=\"cursor:pointer;margin:0px 2px;\" src=\"".$pluginURL."/lib/me2dayBookmarklet.gif\" name=\"Image40\" width=\"20\" height=\"20\" border=\"0\" id=\"Image40\" onclick=\"me2dayBookmarklet();\" title=\"미투데이로 현재 글 북마클릿 하기.\"/>";
	return $target;
}

function get_TagsWithEntryString($entryTag) 
{
	global $database;
	$tags = explode(',', $entryTag);
	$ret = array();
	foreach ($tags as $tag) {
		$tag = UTF8::lessen($tag, 255, '');
		$tag = str_replace('&quot;', '"', $tag);
		$tag = str_replace('&#39;', '\'', $tag);
		$tag = preg_replace('/ +/', ' ', $tag);
		$tag = preg_replace('/[\x00-\x1f]|[\x7f]/', '', $tag);
		$tag = preg_replace('/^(-|\s)+/', '', $tag);
		$tag = preg_replace('/(-|\s)+$/', '', $tag);
		$tag = trim($tag);
		array_push($ret, $tag);
	}
	return implode(' ', $ret);
}

function get_me2dayAccessAPI($target){
	global $owner, $configVal;
	requireComponent('Tattertools.Function.misc');
	$data = misc::fetchConfigVal($configVal);
	if(!empty($_SESSION['userid']) || ($_SESSION['userid'] == $owner)){
		for($i=0;$i<8;$i++){$tempCode = chr(rand(ord('a'), ord('z'))).$tempCode;}
		$hostname = "http://me2day.net";
		$username = $data['me2dayID'];
		$userkey  = $data['me2apiKEY'];
		$userpass = $tempCode . md5($tempCode.$userkey);

		if(!$target){
			$postBody = $_POST['body'];
			$postTags = ($_POST['tags'])?$_POST['tags']." me2blog":"me2blog";
			$postKind = $_POST['kind'];
			$postIcon = $_POST['icon'];
	
			$parameters  = "/api/create_post/{$username}.xml?";
			$parameters .= "post[body]=".urlencode($postBody);
			$parameters .= "&post[tags]=".urlencode($postTags);
			$parameters .= "&post[kind]=".$postKind;
			$parameters .= "&post[icon]=".$postIcon;
		}else{
			if(is_array($target)){
				$parameters  = "/api/get_friends/{$username}.xml?";
				$parameters .= "scope=mytag[{$target[0]}]";	
			}else{
				$parameters  = "/api/get_settings.xml";	
			}
		}
		$urlInfo= parse_url($hostname);
		$query  = "GET {$parameters} HTTP/1.1\r\n";
		$query .= "Host: ".$urlInfo['host']."\r\n";
		$query .= "User-agent: Mozilla/5.0 (Windows; U; Windows NT 5.1; ko; rv:1.8.1.3) Gecko/20070309 Firefox/2.0.0.3\r\n";
		$query .= "me2_application_key: ccd9c043ebb4bc4c8689fd0d0dd746f8\r\n"; //현 플러그인에 할당된 키입니다. 수정 불가.
		$query .= "Accept: text/xml, application/xml, application/xhtml+xml, text/html, */*\r\n";
		$query .= "Accept-Language: ko-kr,ko;q=0.8,en-us;q=0.5,en;q=0.3\r\n";
		$query .= "Accept-Encoding: gzip, deflate\r\n";
		$query .= "Accept-Charset: UTF-8,EUC-KR;q=0.7,*;q=0.7\r\n";
		$query .= "Authorization: Basic " . base64_encode("{$username}:{$userpass}")."\r\n";
		$query .= "Content-type: application/x-www-form-urlencoded; charset=UTF-8\r\n";
		$query .= "Connection: Close\r\n";
		$query .= "\r\n";
		
		$fp = @fsockopen($urlInfo['host'], (($urlInfo['port'])?($urlInfo['port']):("80")), $errno, $errstr, 10);
		if(!$fp){
			$result = "<?xml version=\"1.0\" encoding=\"utf-8\"?>\n<error><code>8888</code><message>접속 실패</message><description>'".$hostname."' 로의 접속에 실패했습니다.</description></error>";
		}else{
			fputs($fp, $query);

			$_header = ""; 
			while(trim($buffer = fgets($fp, 1024)) != ""){ 
				$_header .= $buffer; 
			} 

			$result = "";
			while (!feof($fp)){
				$result .= fgets($fp, 4096);
			} 
		}
		if($target || is_array($target)){
			return $result;
		}else{
			header('Content-Type: text/xml; charset=UTF-8');
			echo $result;
		}
	}else{
		$result = "<?xml version=\"1.0\" encoding=\"utf-8\"?>\n<error><code>9999</code><message>세션 오류</message><description>관리자 세션이 올바르지 않습니다.</description></error>";
		if($target && !is_array($target)){
			return $result;
		}else{
			header('Content-Type: text/xml; charset=UTF-8');
			echo $result;
		}
	}
}

function PN_me2day_Fun(){
	global $owner, $pluginMenuURL, $pluginAccessURL, $pluginHandlerURL, $service, $pluginURL, $configVal;
	requireComponent('Tattertools.Function.misc');
	$data = misc::fetchConfigVal($configVal);

	$_GET["id"]		= ($_POST["id"])?$_POST["id"]:$_GET["id"];
	$_GET["id"]		= isset($_GET["id"])?$_GET["id"]:$data['me2dayID'];
	$_GET["id"]		= ($_GET["id"] == "random")?get_me2dayRandomUser():$_GET["id"];
	$_POST["field"] = isset($_POST["field"])?$_POST["field"]:"id";
	$_POST["direction"] = isset($_POST["direction"])?$_POST["direction"]:"asc";
	$_POST["scope"] = isset($_POST["scope"])?$_POST["scope"]:"all";
	$_POST["mytag"] = isset($_POST["mytag"])?$_POST["mytag"]:"";

	if($data['me2dayID'] == $_GET["id"]){
		$me2MyTags = get_me2dayAccessAPI("mytags");
		preg_match("@<mytags>(.+)\<\/mytags>@", $me2MyTags, $tempTags);
		$tempTags = me2day_uft8html2utf8($tempTags[1]);
		$me2MyTags = explode(" ", $tempTags);
		asort($me2MyTags);
		$tempTags  = ", <span class=\"".($_POST["scope"]=="mytag"?"selectview":"")."\">마이태그</span> <select id=\"myTags\" name=\"myTags\" onchange=\"me2ListView('mytag',this.value); return false;\">";
		$tempTags .= "	<option value=\"\">태그선택</option>";
		foreach ($me2MyTags as $myTag){
			if($_POST["mytag"] == $myTag) {$selected = " selected ";}else{$selected = "";}
			$tempTags .= "	<option value=\"{$myTag}\" {$selected}>{$myTag}</option>";
		}
		$tempTags .= "</select>";
	}

	$person = me2PersonInfo($_GET["id"]);
	$me2FamilyLine = me2FamilyLine($_GET["id"]);
	list($me2Friends, $intimateCount, $familiesCount) = me2Friends($_GET["id"], $_POST["field"], $_POST["direction"], $_POST["scope"], $_POST["mytag"]);
	$sortChk = $_POST["field"].$_POST["direction"];
	?>
	<script type="text/javascript">
	//<![CDATA[
		window.addEventListener("load", execLoadFunction, false);
		function execLoadFunction() {
			tempDiv = document.createElement("DIV");
			tempDiv.style.clear = "both";
			document.getElementById("part-me2day-fun").appendChild(tempDiv);
		}

		function me2ListMode(field, direction) {
			document.getElementById('field').value = field;
			document.getElementById('direction').value = direction;
			document.getElementById('me2ListForm').submit();
		}
		function me2ListView(scope, mytag) {
			if(scope == "mytag" && mytag == "") return false;
			document.getElementById('scope').value = scope;
			document.getElementById('mytag').value = mytag;
			document.getElementById('me2ListForm').submit();
		}
	//]]>
	</script>
	<link rel="stylesheet" type="text/css" media="screen" href="<?php echo $pluginURL;?>/lib/me2style.css"/>
	<script type="text/javascript" src="<?php echo $pluginURL;?>/lib/prototype.js"></script>
	<script type="text/javascript" src="<?php echo $pluginURL;?>/lib/moo.fx.js"></script>
	<script type="text/javascript" src="<?php echo $pluginURL;?>/lib/tooltip.js"></script>
	<form id="me2ListForm" name="me2ListForm" method="post">
	<input type="hidden" id="id" name="id" value="<?php echo $_GET["id"];?>" />
	<input type="hidden" id="field" name="field" value="<?php echo $_POST["field"];?>" />
	<input type="hidden" id="direction" name="direction" value="<?php echo $_POST["direction"];?>" />
	<input type="hidden" id="scope" name="scope" value="<?php echo $_POST["scope"];?>" />
	<input type="hidden" id="mytag" name="mytag" value="<?php echo $_POST["mytag"];?>" />
	<div id="part-me2day-fun" class="part">
		<h2 class="caption"><span class="main-text">me2day 가계도와 친구 목록을 보여줍니다.</span></h2>
		<div id="header_main">
			<div id="header_face">
				<img src='<?php echo $person['face'];?>' width='77' height='77' onError='this.src="http://me2day.net/images/profile.gif";' />
			</div>
			<div id="header_sub">
				<div id="header_title">
					<span class="idname"><a href="<?php echo $person['me2dayHome'];?>" onclick="window.open(this.href); return false;"><?php echo $person['id'];?></a>'s me2day </span>
					<span class="nickname">by <?php echo ($person['homepage'])?'<a href="'.$person['homepage'].'" onclick="window.open(this.href); return false;">'.$person['nickname'].'</a>':$person['nickname'];?></span>
				</div>
				<div id="description">&nbsp;&raquo; <?php echo UTF8::lessenAsEm($person['description'], 150);?></div>
				<div id="friendsCount">
					&nbsp;&raquo; 친구 : 
						<a href="#" onclick="me2ListView('all','');" title="모든친구 보기"><span class="<?php echo ($_POST["scope"]=="all")?"selectview":"";?>">모두(<?php echo $person['friendsCount'];?>명)</span></a>, 
						<a href="#" onclick="me2ListView('close','');" title="친한친구 보기"><span class="<?php echo ($_POST["scope"]=="close")?"selectview":"";?>">친한친구(<?php echo $intimateCount;?>명)</span></a>, 
						<a href="#" onclick="me2ListView('family','');" title="직계존속 보기"><span class="<?php echo ($_POST["scope"]=="family")?"selectview":"";?>">직계존속(<?php echo $familiesCount;?>명)</span></a>
						<?php echo $tempTags;?>
				</div>
				<div id="friendsSort">&nbsp;&raquo; 정렬 : 
					아이디[<a href="#" onclick="me2ListMode('id','asc');" title="오름차순"><span class="<?php echo ($sortChk=="idasc")?"selectsort":"";?>">▲</span></a>|<a href="#" onclick="me2ListMode('id','desc');" title="내림차순"><span class="<?php echo ($sortChk=="iddesc")?"selectsort":"";?>">▼</span></a>], 
					닉네임[<a href="#" onclick="me2ListMode('nickname','asc');" title="오름차순"><span class="<?php echo ($sortChk=="nicknameasc")?"selectsort":"";?>">▲</span></a>|<a href="#" onclick="me2ListMode('nickname','desc');" title="내림차순"><span class="<?php echo ($sortChk=="nicknamedesc")?"selectsort":"";?>">▼</span></a>],
					친구수[<a href="#" onclick="me2ListMode('friendsCount','asc');" title="오름차순"><span class="<?php echo ($sortChk=="friendsCountasc")?"selectsort":"";?>">▲</span></a>|<a href="#" onclick="me2ListMode('friendsCount','desc');" title="내림차순"><span class="<?php echo ($sortChk=="friendsCountdesc")?"selectsort":"";?>">▼</span></a>]
				</div>
			</div>
		</div>
		<div id="header_hr"></div><div style="clear:both;"></div>
		<div id="content_main">
			<div id="me2FamilyFriends">
				<?php echo $me2FamilyLine;?>
				<?php echo $me2Friends;?>
			</div>
		</div>
		<div style="clear:both;"></div><div id="footer_hr"></div>
		<div id="footer_main">
			<div id="footer_sub"></div>
		</div>
	</div>
	</form>
<?php 
}

function CT_me2dayFun_DataSet($DATA){
	requireComponent('Tattertools.Function.misc');
	$cfg = misc::fetchConfigVal($DATA);
	if(!$cfg['me2dayID'] || !$cfg['me2apiKEY'] || strlen($cfg['me2apiKEY']) != 8) return "::입력 오류::\n\n아이디와 사용자키를 확인하세요. 필수 항목입니다.  \n(사용자키는 8자리 입니다.)";
	return true;
}
?>